apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ thanos_name }}-rule
  name: {{ thanos_name }}-rule
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ thanos_rule_replicas }}
  selector:
    matchLabels:
      name: {{ thanos_name }}-rule
  serviceName: {{ thanos_name }}-rule
  template:
    metadata:
      labels:
        name: {{ thanos_name }}-rule
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ thanos_name }}-rule ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ thanos_name }}-rule ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - rule
        - --alert.label-drop=rule_by
        - --alert.label-drop=scrape_by
        - --alert.query-url=https://alertmanager.{{ root_domain }}
        - --alertmanagers.url=dns+http://{{ alertmanager_name }}.{{ namespace }}.svc.{{ cluster_domain }}:9093
        - --alertmanagers.send-timeout=3s
        - --data-dir=/var/thanos/rule
        - --eval-interval={{ thanos_rule_eval_interval }}
        - --grpc-address=0.0.0.0:10901
        - --http-address=0.0.0.0:10902
        - --label=rule_by="$(POD_NAME)"
{% if do_debugs %}
        - --log.level=debug
{% else %}
        - --log.level=info
{% endif %}
        - --objstore.config=$(OBJSTORE_CONFIG)
        - --query={{ thanos_name }}-query.{{ namespace }}.svc.{{ cluster_domain }}
        - --rule-file=/rules.d/*.yaml
        - --tsdb.block-duration=2h
        - --tsdb.retention=48h
        env:
        - name: OBJSTORE_CONFIG
          valueFrom:
            secretKeyRef:
              key: thanos.yaml
              name: {{ thanos_name }}-store
        - name: POD_NAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='thanos'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            path: /-/healthy
            port: 10902
          periodSeconds: 30
        name: thanos
        ports:
        - containerPort: 10901
          name: grpc
        - containerPort: 10902
          name: http
        readinessProbe:
          failureThreshold: 20
          httpGet:
            path: /-/ready
            port: 10902
          periodSeconds: 5
        resources:
          limits:
            cpu: "{{ thanos_rule_cpu_limit }}"
            memory: "{{ thanos_rule_memory_limit }}"
          requests:
            cpu: "{{ thanos_rule_cpu_request }}"
            memory: "{{ thanos_rule_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/thanos/rule
          name: data
        - mountPath: /rules.d
          name: rules
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-monitoring
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ thanos_name }}-rule
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: rules
        projected:
          sources:
{% for rule_file in prometheus_rules %}
          - configMap:
              items:
              - key: {{ rule_file }}.yaml
                path: {{ rule_file }}.yaml
              name: {{ prometheus_name }}-rule-{{ rule_file | lower | regex_replace('[\\.-_ ]', '') }}
{% endfor %}
{% if notify_outside_business_hours %}
          - configMap:
              items:
              - key: nonworkinghour.yaml
                path: nonworkinghour.yaml
              name: {{ prometheus_name }}-rule-nwh
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ thanos_rule_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
